/* $Id: 8514.h,v 1.2 1998/11/02 04:38:50 brian Exp $
******************************************************************************

   IBM 8514 Series/Standard -- register definitions and macros

   Copyright (C) 1998		Brian S. Julin	[bri@forcade.calyx.com]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/


#define	I8514_SETUP		0x102
	#define	I8514_SETUP_WAKE			0x01
	#define	I8514_SETUP_RSVD			0xfe

#define	I8514_DISP_STAT		0x2E8
	#define	I8514_DISP_STAT_SENSE		0x0001
	#define	I8514_DISP_STAT_VBLANK		0x0002
	#define	I8514_DISP_STAT_HTOGGLE		0x0004
	#define	I8514_DISP_STAT_RSVD		0xfff8

#define	I8514_H_TOTALw		0x2E8
#define	I8514_H_TOTALr		0x26E8
	#define	I8514_H_TOTAL_MASK		0x01ff
	#define	I8514_H_TOTAL_RSVD		0xfe00

#define	I8514_DAC_MASK		0x2EA

#define	I8514_DAC_R_INDEX	0x2EB

#define	I8514_DAC_W_INDEX	0x2EC

#define	I8514_DAC_DATA		0x2ED

#define	I8514_H_DISP_END		0x6E8
	#define	I8514_H_DISP_END_MASK		0x00ff
	#define	I8514_H_DISP_END_RSVD		0xff00

#define	I8514_H_SYNC_STRT	0xAE8
	#define	I8514_H_SYNC_STRT_MASK		0x00ff
	#define	I8514_H_SYNC_STRT_RSVD		0xff00

#define	I8514_H_SYNC_CNTL	0xEE8
	#define	I8514_H_SYNC_WID			0x001f
	#define	I8514_H_SYNC_POL			0x0020
	#define	I8514_H_SYNC_CNTL_RSVD		0xffc0

#define	I8514_V_TOTAL		0x12E8
	#define	I8514_V_TOTAL_ADJ		0x0007
	#define	I8514_V_TOTAL_MASK		0x0ff8
	#define	I8514_V_TOTAL_RSVD		0xf000

#define	I8514_V_DISP_END		0x16E8
	#define	I8514_V_DISP_END_ADJ		0x0007
	#define	I8514_V_DISP_END_MASK		0x0ff8
	#define	I8514_V_DISP_END_RSVD		0xf000

#define	I8514_V_SYNC_STRT			0x1AE8
	#define	I8514_V_SYNC_STRT_ADJ		0x0007
	#define	I8514_V_SYNC_STRT_MASK		0x0ff8
	#define	I8514_V_SYNC_STRT_RSVD		0xf000

#define	I8514_V_SYNC_CNTL	0x1EE8
	#define	I8514_V_SYNC_WIDTH		0x001f
	#define	I8514_V_SYNC_POL			0x0020
	#define	I8514_RSVD			0xffc0

#define	I8514_DISP_CNTL		0x22E8
	#define	I8514_DISP_CNTL_ODDBNKENAB	0x0001
	#define	I8514_DISP_CNTL_MEMCFG_MASK	0x0006
	#define	I8514_DISP_CNTL_MEMCFG_NORM	0x0000
	#define	I8514_DISP_CNTL_MEMCFG_DIV2	0x0002
	#define	I8514_DISP_CNTL_MEMCFG_DIV3	0x0004
	#define	I8514_DISP_CNTL_MEMCFG_DIV4	0x0006
	#define	I8514_DISP_CNTL_DBLSCAN		0x0008
	#define	I8514_DISP_CNTL_INTERLACE	0x0010
	#define	I8514_DISP_CNTL_DISPEN_MASK	0x0060
	#define	I8514_DISP_CNTL_DISPEN_ENBL	0x0020
	#define	I8514_DISP_CNTL_DISPEN_DSBL	0x0060
	#define	I8514_DISP_CNTL_RSVD		0xff80

#define	I8514_SUBSYS_STAT	0x42E8
	#define	I8514_SUBSYS_IRQ_STAT_BLANK	0x0001
	#define	I8514_SUBSYS_IRQ_STAT_PICK	0x0002
	#define	I8514_SUBSYS_IRQ_STAT_BADIO	0x0004
	#define	I8514_SUBSYS_IRQ_STAT_GPIDLE	0x0008
	#define	I8514_MONITORID_MASK		0x0070
	#define	I8514_MONITORID_8507		0x0010
	#define	I8514_MONITORID__8514		0x0020
	#define	I8514_MONITORID_8503		0x0050
	#define	I8514_MONITORID_8512		0x0060
	#define	I8514_SUBSYS_STAT_8PLANE		0x0080
	#define	I8514_CHIP_REV_MASK		0x0f00

#define	I8514_SUBSYS_CNTLw	0x42E8
	#define	I8514_SUBSYS_CNTL_RSVD		0x00f0
	#define	I8514_SUBSYS_IRQ_ENB_BLANK	0x0100
	#define	I8514_SUBSYS_IRQ_ENB_PICK	0x0200
	#define	I8514_SUBSYS_IRQ_ENB_BADIO	0x0400
	#define	I8514_SUBSYS_IRQ_ENB_GPIDLE	0x0800
	#define	I8514_CHPTEST			0x2000
	#define	I8514_GPCTRL			0xc000

#define	I8514_ROM_PAGE_SEL	0x46e8
	#define	I8514_ROM_PAGE_SEL_MASK		0x0007
	#define	I8514_VGA_WAKE			0x0008
	#define	I8514_VGA_SLEEP			0x0010
	#define	I8514_ROM_PAGE_SEL_RSVD		0xffe0

#define	I8514_ADVFUNC_CNTL	0x4AE8
	#define	I8514_VGA_ENB			0x0001
	#define	I8514_4AE8_RSVD_SET_MASK		0x000A
	#define	I8514_4AE8_RSVD_SET_VAL		0x0002
	#define	I8514_CLKSEL			0x0004
	#define	I8514_4AE8_RSVD			0xfff0
