
#include <ggi/ggi.h>
#include <ggi/gwt.h>
#include <stdio.h>

ggi_pixel white, black, red, green;

#define REDRAW \
/*	ggiSetGCForeground(vis, black); \
	ggiFillscreen(vis); \
*/	ggiSetGCForeground(vis, white); \
	gwtFillscreen(rootwin); \
	ggiSetGCForeground(vis, red); \
	gwtFillscreen(subwin); \
	ggiSetGCForeground(vis, green); \
	gwtFillscreen(subsubwin); \
/*	ggiSetGCForeground(vis, black); \
	gwtDrawRect(rootwin); \
	gwtDrawRect(subwin); \
	gwtDrawRect(subsubwin); \
*/	ggiFlush(vis)


static void printRegion(gwt_region_t r)
{
  ggi_coord o,s;
  int n = 0;

  while (gwtIterateRect(r, &n, &o, &s)) {
    printf("  rect no.%d : top=%d left=%d height=%d width=%d\n",
	   n, o.x, o.y, s.y, s.y);
  }
  return;
}

int main(int argc, char ** argv)
{
	int key;
	int wx=2, wy=2;
	int finished=0;

	ggi_visual_t vis;
	ggi_mode tm;
	gwt_window_t rootwin, subwin, subsubwin;
	ggi_color col;
	gwt_region_t invalid_region;
	gwt_region_t visible_region;

	ggiInit();
	gwtInit();
	vis=ggiOpen(NULL);
	gwtAttach(vis);
	
	ggiCheckGraphMode(vis, GT_AUTO, GT_AUTO, GT_AUTO, GT_AUTO, GT_AUTO, &tm);
	ggiSetMode(vis, &tm);

	col.r=col.g=col.b=0x0000;
	black=ggiMapColor(vis, &col);
	col.r=col.g=col.b=0xffff;
	white=ggiMapColor(vis, &col);
	col.g=col.b=0x0000;
	red=ggiMapColor(vis, &col);
	col.r=0x0000;
	col.g=0xffff;
	green=ggiMapColor(vis, &col);

	gwtCreateRootWindow(vis, &rootwin);
	gwtCreateWindow(rootwin, &subwin);
	gwtCreateWindow(subwin, &subsubwin);

	gwtSetGeometry(subwin, wx, wy, 320, 240);
	gwtSetGeometry(subsubwin, wx-8, wy-8, 160, 120);
	gwtShow(subwin);
	gwtShow(subsubwin);

do {
	REDRAW;
	
	do key = ggiGetc(vis);
	/* TODO: Update this to use GII correctly (or GWT) */
	while ((key == GIIK_VOID) || (key == GIIK_Shift));

	switch (key) {
	case 's':		/* up*/
		wy-=16; break;
	case 'x':		/* down */
		wy+=16; break;
	case 'o':		/* left */
		wx-=16; break;
	case 'p':		/* right */
		wx+=16; break;
	case 't':		/* right */
		if (gwtIsHidden(subwin)) gwtShow(subwin); else gwtHide(subwin); break;
	case ' ':		/* finish */
		finished=1; break;

	}

	gwtGetInvalidRegion(subwin, invalid_region);
	printf("Invalid region:\n");
	printRegion(invalid_region);

	/*
	gwtGetVisibleRegion(subwin, visible_region);

	printf("Visible region:\n");
	printRegion(visible_region);
	printf("\n");
	*/
	gwtMove(subwin, wx, wy);
	gwtMove(subsubwin, wx-8, wy-8);
} while (!finished);

	ggiFlush(vis);

	gwtDestroy(rootwin);	/* closes children first */
	gwtDetach(vis);
	ggiClose(vis);
	gwtExit();
	ggiExit();
	exit(0);
}

